/* UTF-8 !! */

/****************************************************************************
 ** Hyne Final Fantasy VIII Save Editor
 ** Copyright (C) 2013 Arzel Jérôme <myst6re@gmail.com>
 **
 ** This program is free software: you can redistribute it and/or modify
 ** it under the terms of the GNU General Public License as published by
 ** the Free Software Foundation, either version 3 of the License, or
 ** (at your option) any later version.
 **
 ** This program is distributed in the hope that it will be useful,
 ** but WITHOUT ANY WARRANTY; without even the implied warranty of
 ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 ** GNU General Public License for more details.
 **
 ** You should have received a copy of the GNU General Public License
 ** along with this program.  If not, see <http://www.gnu.org/licenses/>.
 ****************************************************************************/

#include "FF8Text.h"

const char *FF8Text::_caract[240] =
{
//	"","\n{NewPage}\n","\n",""/*Names*/,""/*vars*/,""/*icons*/,""/*colors*/,""/*Next?*/,""/*?*/,""/*?*/,""/*?*/,""/*?*/,""/*magic*/,""/*items*/,""/*locations*/,""/*?*/,
//	"","","","","","","","","",""/*jp19*/,""/*jp1a*/,""/*jp1b*/,""/*jp1c*/,"","","",
	" ","0","1","2","3","4","5","6","7","8","9","%","/",":","!","?",
	"…","+","-","=","*","&","「","」","(",")","·",".",",","~","“","”",
	"‘","#","$","'","_","A","B","C","D","E","F","G","H","I","J","K",
	"L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z","a",
	"b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q",
	"r","s","t","u","v","w","x","y","z","À","Á","Â","Ä","Ç","È","É",
	"Ê","Ë","Ì","Í","Î","Ï","Ñ","Ò","Ó","Ô","Ö","Ù","Ú","Û","Ü","Œ",
	"ß","à","á","â","ä","ç","è","é","ê","ë","ì","í","î","ï","ñ","ò",
	"ó","ô","ö","ù","ú","û","ü","œ","","[","]","■","○","♦","【","】",
	"□","","『","』","",";","","¯","×","","","↓","°","¡","¿","─",
	"«","»","±","♫","","↑","","","","™","<",">","","","","",
	"","","","","","","","","","","","","","","","",
	"","","®","","","","","","{in}","{e }","{ne}","{to}","{re}","{HP}","{l }","{ll}",
	"{GF}","{nt}","{il}","{o }","{ef}","{on}","{ w}","{ r}","{wi}","{fi}","{EC}","{s }","{ar}","{FE}","{ S}","{ag}"
};

const char *FF8Text::_caractJp[240] =
{
	"バ","ば","ビ","び","ブ","ぶ","ベ","べ","ボ","ぼ","ガ","が","ギ","ぎ","グ","ぐ",
	"ゲ","げ","ゴ","ご","ザ","ざ","ジ","じ","ズ","ず","ゼ","ぜ","ゾ","ぞ","ダ","だ",
	"ヂ","ぢ","ヅ","づ","デ","で","ド","ど","ヴ","パ","ぱ","ピ","ぴ","プ","ぷ","ペ",
	"ぺ","ポ","ぽ","０","１","２","３","４","５","６","７","８","９","、","。","　",
	"ハ","は","ヒ","ひ","フ","ふ","ヘ","へ","ホ","ほ","カ","か","キ","き","ク","く",
	"ケ","け","コ","こ","サ","さ","シ","し","ス","す","セ","せ","ソ","そ","タ","た",
	"チ","ち","ツ","つ","テ","て","ト","と","ウ","う","ア","あ","イ","い","エ","え",
	"オ","お","ナ","な","ニ","に","ヌ","ぬ","ネ","ね","ノ","の","マ","ま","ミ","み",
	"ム","む","メ","め","モ","も","ラ","ら","リ","り","ル","る","レ","れ","ロ","ろ",
	"ヤ","や","ユ","ゆ","ヨ","よ","ワ","わ","ン","ん","ヲ","を","ッ","っ","ャ","ゃ",
	"ュ","ゅ","ョ","ょ","ァ","ぁ","ィ","ぃ","ゥ","ぅ","ェ","ぇ","ォ","ぉ","Ａ","Ｂ","Ｃ",
	"Ｄ","Ｅ","Ｆ","Ｇ","Ｈ","Ｉ","Ｊ","Ｋ","Ｌ","Ｍ","Ｎ","Ｏ","Ｐ","Ｑ","Ｒ",
	"Ｓ","Ｔ","Ｕ","Ｖ","Ｗ","Ｘ","Ｙ","Ｚ","！","？","…","＋","－","＝","＊","／",
	"％","＆","「","」","（","）","収","容","所","駅","・","．","，","：","～","ー"
};

const char *FF8Text::_caractJp19[240] =
{
	"ｅ","Ⅷ","悪","安","暗","闇","以","異","違","一","員","右","運","鋭","液","越",
	"園","援","炎","煙","押","屋","音","下","化","何","果","火","我","会","回","快",
	"海","格","確","覚","学","喚","完","間","関","岸","顔","器","機","気","技","吸",
	"急","給","居","巨","共","強","恐","近","金","空","軍","形","警","撃","激","血",
	"月","剣","見","験","減","言","個","呼","己","御","光","効","口","好","攻","校",
	"甲","行","降","高","合","告","黒","獄","今","混","佐","左","砂","催","殺","三",
	"山","散","斬","使","士","始","止","死","試","事","持","時","次","治","自","失",
	"実","射","捨","弱","取","手","殊","受","呪","修","終","臭","襲","集","出","術",
	"女","召","将","少","消","称","笑","上","場","常","状","食","審","心","振","新",
	"針","震","人","刃","水","睡","制","性","成","整","生","精","聖","製","青","石",
	"切","折","説","先","千","宣","戦","選","全","蘇","早","相","装","増","即","息",
	"速","属","続","体","対","態","袋","隊","代","大","択","誰","弾","断","男","値",
	"地","着","中","仲","虫","調","超","長","沈","追","通","低","定","敵","的","徹",
	"撤","鉄","店","転","点","電","吐","怒","倒","刀","塔","盗","当","等","統","逃"
};

const char *FF8Text::_caractJp1a[240] =
{
	"頭","闘","動","同","特","毒","突","内","二","入","認","能","波","敗","倍","買",
	"売","爆","発","判","半","反","班","費","避","非","飛","備","尾","必","不","浮",
	"負","武","部","風","復","物","分","兵","平","変","返","歩","放","方","法","砲",
	"防","本","魔","味","岬","脈","眠","夢","無","名","命","明","滅","面","黙","目",
	"野","薬","与","用","要","来","雷","落","乱","嵐","理","率","流","了","料","領",
	"力","冷","霊","連","狼","嘯","差","込","決","×","東","前","禁","道","具","系",
	"設","翼","肩","身","知","欠","殴","牙","苦","進","魂","作","帰","思","兄","弟",
	"仁","義","刊","処","助","怪","勝","種","程","度","際","影","界","画","表","響",
	"項","各","得","世","獲","基","有","割","意","情","存","加","可","他","多","示",
	"欲","話","経","偽","『","』","神","暴","支","型","遺","医","育","宇","塩","応",
	"王","家","花","階","凱","街","官","館","記","客","教","業","局","区","掘","窟",
	"渓","計","建","研","現","庫","湖","工","広","構","港","荒","講","国","査","祭",
	"市","室","車","住","昇","乗","城","森","図","正","席","跡","接","旋","船","層",
	"操","造","束","族","村","谷","探","段","宙","柱","駐","庭","艇","邸","島","堂"
};

const char *FF8Text::_caractJp1b[240] =
{
	"洞","念","拝","白","漠","畑","編","墓","宝","民","務","門","洋","裏","陸","立",
	"寮","礼","列","路","廊","牢","問","績","第","退","頼","北","砕","究","博","書",
	"主","々","保","健","訓","練","施","秘","密","向","質","配","直","利","単","数",
	"照","指","類","注","置","最","参","交","換","号","粉","羽","竜","糸","爪","極",
	"南","札","英","雄","万","彦","骨","筆","習","創","雑","誌","題","後","改","犯",
	"破","壊","導","草","菜","球","更","偉","未","隠","円","輪","触","賢","者","皮",
	"溶","解","活","角","楽","腕","赤","守","鈴","救","師","星","忘","信","件","結",
	"晶","謎","休","燃","古","鳥","銃","原","丘","陵","番","諸","雪","天","封","鎖",
	"初","記","憶","位","期","移","足","在","報","優","写","真","順","象","帯","議",
	"聞","視","走","魚","式","俺","騎","鬼","開","外","威","君","素","比","劣","難",
	"遠","愛","皆","紹","介","犬","満","枚","字","辺","引","小","別","除","限","両",
	"功","良","継","伝","過","側","重","複","係","打","語","圏","条","互","末","倉",
	"敷","私","圧","縮","子","供","頃","感","葉","残","待","離","元","否","線","約"
};
